︠bbc171ba-2807-4a75-9f60-65b299e78686is︠
%hide
%html

<H3  ALIGN="CENTER"><B><FONT COLOR="#A30856">
Roller coaster design contest
</FONT></B></H3>

<FONT SIZE="-1">(From 
"<A HREF="http://www1.hollins.edu/depts/math/hammer/coaster">
 Design of a Thrilling Roller Coaster</A>,"
    by Patricia W. Hammer, Jessica A. King, and Steve Hammer.)
</FONT>
<P><BR>

How can we make the most thrilling possible roller coaster?!
The goal of this contest is to model and design 
a straight stretch roller coaster that satisfies 
the following restrictions regarding height, length, slope, 
and differentiability of coaster path:
<UL>
  <LI>The total horizontal length of the straight stretch 
must be less than 200 feet.
  <LI>The track must start 75 feet above the ground and end at ground level.
  <LI>At no time can the track be more than 75 feet above the ground or go below ground level.
  <LI>No ascent or descent can be steeper than 80 degrees from the horizontal.
  <LI>The roller coaster must start and end with a zero degree incline.
  <LI>The path of the coaster must be modeled using differentiable functions.
</UL>

The winning entry will be the coaster design that has the maximum 
<FONT COLOR="#930856"><U>thrill</U></FONT> based on the following definition: <P><BR>

"The thrill of a drop is defined to be the angle of steepest descent 
in the drop (in radians) multiplied by the total vertical 
    distance in the drop.  The thrill of the coaster is defined as 
    the sum of the thrills of each drop."

<P><BR>

Feel free to work alone, or in teams of 2-3 students!

<P><BR>

<FONT COLOR="#034826">
<B>Some ideas and hints</B>
</FONT>
<BR>&nbsp;<BR>
This is an open-ended design problem. There is no "correct" 
answer.  <P>

Try to first design a coaster with two drops, and see what 
maximum thrill you can get by adding the thrill of both
drops.  <P>

Feel free to use any functions, as long as they are differentiable. <P>

But, if your function has more than 4 parameters, think about 
how you might solve for their numerical values.  In fact, think about 
whether there might be ways to help make your drops steeper by 
imposing additional conditions on various derivatives of your 
function.
︡a77b0d35-fa3c-4aad-90c3-07e57526ee12︡{"hide":"input"}︡{"html":"\n<H3  ALIGN=\"CENTER\"><B><FONT COLOR=\"#A30856\">\nRoller coaster design contest\n</FONT></B></H3>\n\n<FONT SIZE=\"-1\">(From \n\"<A HREF=\"http://www1.hollins.edu/depts/math/hammer/coaster\">\n Design of a Thrilling Roller Coaster</A>,\"\n    by Patricia W. Hammer, Jessica A. King, and Steve Hammer.)\n</FONT>\n<P><BR>\n\nHow can we make the most thrilling possible roller coaster?!\nThe goal of this contest is to model and design \na straight stretch roller coaster that satisfies \nthe following restrictions regarding height, length, slope, \nand differentiability of coaster path:\n<UL>\n  <LI>The total horizontal length of the straight stretch \nmust be less than 200 feet.\n  <LI>The track must start 75 feet above the ground and end at ground level.\n  <LI>At no time can the track be more than 75 feet above the ground or go below ground level.\n  <LI>No ascent or descent can be steeper than 80 degrees from the horizontal.\n  <LI>The roller coaster must start and end with a zero degree incline.\n  <LI>The path of the coaster must be modeled using differentiable functions.\n</UL>\n\nThe winning entry will be the coaster design that has the maximum \n<FONT COLOR=\"#930856\"><U>thrill</U></FONT> based on the following definition: <P><BR>\n\n\"The thrill of a drop is defined to be the angle of steepest descent \nin the drop (in radians) multiplied by the total vertical \n    distance in the drop.  The thrill of the coaster is defined as \n    the sum of the thrills of each drop.\"\n\n<P><BR>\n\nFeel free to work alone, or in teams of 2-3 students!\n\n<P><BR>\n\n<FONT COLOR=\"#034826\">\n<B>Some ideas and hints</B>\n</FONT>\n<BR>&nbsp;<BR>\nThis is an open-ended design problem. There is no \"correct\" \nanswer.  <P>\n\nTry to first design a coaster with two drops, and see what \nmaximum thrill you can get by adding the thrill of both\ndrops.  <P>\n\nFeel free to use any functions, as long as they are differentiable. <P>\n\nBut, if your function has more than 4 parameters, think about \nhow you might solve for their numerical values.  In fact, think about \nwhether there might be ways to help make your drops steeper by \nimposing additional conditions on various derivatives of your \nfunction."}︡{"done":true}︡









