︠3d5a2adc-356e-4b9b-8a4e-bd313ac565f2si︠
%hide
%html

<H3  ALIGN="CENTER"><B><FONT COLOR="#A30856">
A seriously silly model of romantic love!
</FONT></B></H3>


<TABLE ALIGN="CENTER" WIDTH="80%" BORDER="0"  CELLSPACING="0"  CELLPADDING="8">
  <TR VALIGN="TOP">
    <TD BGCOLOR="#DFDFDF">
      <FONT COLOR="#034826">
      <I>How do I love thee? Let me model the ways!</I>
      </FONT><BR>
      <FONT SIZE="-1">- My apologies to Elizabeth Barrett Browning
      for nerdifying her lovely poem!
      </FONT>
    </TD>
  </TR>
</TABLE>

<P>
<FONT SIZE="-1">(Adapted from various sources.  But if you're 
seriously interested, check out
<A HREF="http://www.earlham.edu/~pardhan/courses/general_notes/de/DynamicLove.pdf">this article</A>!)
</FONT>

<!--
<P>
<B>Prelude:</B> Please complete 
<A HREF="./quiz_on_love_style.pdf">this brief self-assessment 
of your romantic personality</A> before working on the 
rest of today's lab.
-->

<P>

<FONT COLOR="#034826">
<B>The scene</B>
</FONT>
<P>
Juliet loves Romeo, and Romeo loves Juliet, 
at least at time t=0.  The question is, how will their 
feelings evolve with time, and as they meet other, potentially 
fascinating, new people!  Here is our modeling strategy:


<UL>
  <LI>We will model the rate of change in their 
feelings, with respect to time.
  <LI>Let J(t) = a function that represents Juliet's 
love for Romeo at time t.  <BR>The sign and magnitude of J(t) 
indicate how much Juliet loves (or hates, if it is 
negative) Romeo.
  <LI>Let R(t) = a similar function of Romeo's 
feelings about Juliet.
</UL>

<FONT COLOR="#034826">
<B>Love is an ever changing function</B>
</FONT>
<P>&nbsp;<BR>
To help you get comfortable with these love functions and their 
phase plots, let us begin with a warmup exercise.
<P>
<FONT COLOR="#000066">
Each graph below shows the time history of various hypothetical 
love affairs between Juliet and Romeo.  Interpret what is 
happening in each graph.
</FONT>
<TABLE ALIGN="CENTER" WIDTH="80%" BORDER="0"  CELLSPACING="0"  CELLPADDING="8">
  <TR VALIGN="TOP">
    <TD ALIGN="CENTER">
      <IMG SRC="./love_affairs_sketch1.png" width="350">
    </TD>
    <TD ALIGN="CENTER">
      <IMG SRC="./love_affairs_sketch2.png" width="350">
    </TD>
  </TR>
  <TR VALIGN="TOP">
    <TD ALIGN="CENTER">
      <B>Fig. 1</B>
    </TD>
    <TD ALIGN="CENTER">
      <B>Fig. 2</B>
    </TD>
  </TR>


  <TR VALIGN="TOP">
    <TD ALIGN="CENTER">
      <IMG SRC="./love_affairs_sketch3.png" width="350">
    </TD>
    <TD ALIGN="CENTER">
      <IMG SRC="./love_affairs_sketch4.png" width="350">
    </TD>
  </TR>
  <TR VALIGN="TOP">
    <TD ALIGN="CENTER">
      <B>Fig. 3</B>
    </TD>
    <TD ALIGN="CENTER">
      <B>Fig. 4</B>
    </TD>
  </TR>
</TABLE>
      
      
<FONT COLOR="#034826">
<B>Building a simple love-affair model</B>
</FONT>
<BR>&nbsp;<BR>
For simplicity, we will assume that there are only two 
factors that affect Juliet's future feelings for Romeo: 
(i) her own current feelings about him, and (ii) his 
current feelings towards her.  And similarly, there
are only two factors that affect Romeo's  future
feelings about Juliet. <P>

As usual, we want to think in terms of the derivatives 
$\displaystyle \frac{dJ}{dt}$ and $\displaystyle \frac{dR}{dt}$, 
in order to model $J(t)$ and $R(t)$.  Here are some question 
to explore:
<UL>
  <LI>Suppose we ignore the magnitudes of
$J(t)$ and $R(t)$, and consider only their signs.  
Write a couple of sentences discussing how many different
combinations of feelings are possible, and what they are 
      (e.g., love-hate, love-love,<SUB>&nbsp;</SUB>etc.).
  <LI>We<SUP>&nbsp;</SUP>want to express 
$J^\prime(t)$ and $R^\prime(t)$ as functions of the variables they depend 
upon.  To help you think through this, here is an example of a 
scenario to consider: Suppose Romeo is primarily connected 
to his own feelings and disconnected from Juliet's.  And 
suppose Juliet has the opposite personality.  Then, one
simple model for $J^\prime$ and $R^\prime$ would look like: <BR>
&nbsp; &nbsp; <SUP>&nbsp;</SUP> $J^\prime(t) = - J + R $ <BR>
&nbsp; &nbsp; <SUP>&nbsp;</SUP> $R^\prime(t) = - J + R $
<P>
Here the negative signs on the 1st term suggest both 
lovers respond negatively when Juliet's love for Romeo 
increases!  The positive signs on the 2nd term suggests 
both lovers fall deeper in love as Romeo's love for 
Juliet increases.  True, it's weird, but there is plenty of 
weirdness in the real world! <P>
<FONT COLOR="#000066">
Construct a few other simple models of this type.  That is: <BR>
&nbsp; &nbsp; $J^\prime(t) = $ term(s) that<SUP>&nbsp;</SUP> 
depend on $J$ and $R$ <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
Explain what sign you want for the term(s) and why? 
<BR>
&nbsp; &nbsp; $R^\prime(t) = $ term(s)<SUP>&nbsp;</SUP>that 
depend on $J$ and $R$ <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
Explain what sign you want for the term(s) and why? 
</FONT>
</UL>
    
A general formulation of the model 
that includes all the cases considered above is <BR>

&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $J^\prime(t) = a J + b R $ <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $R^\prime(t) = c J + d R $ <P>
where all the coefficients denote constant parameter 
values that model different personality types and/or 
behavior traits.  For example, here is one classification 
scheme based on Romeo's personality that has been proposed 
in the literature: 

<OL>
  <LI><I>Eager beaver</I>: $ c > 0$ and $ d > 0$ 
(Romeo is encouraged by his own feelings as well as by Juliet's.)
  <LI><I>Narcissistic nerd</I>: $ c < 0$ and $ d > 0$ 
(Romeo wants more of what he feels, but retreats from Juliet's 
feelings.)
  <LI><I>Cautious lover</I>: $ c > 0$ and $ d < 0$ 
(Romeo retreats from his own feelings, but is encouraged by
Juliet's.)
  <LI><I>Hermit</I>: $ c < 0$ and $ d < 0$ 
(Romeo retreats from his own feelings as well as from 
Juliet's.)
</OL>
︡2df8a05c-ba72-4670-b39c-babe007cfbea︡{"hide":"input"}︡{"html":"\n<H3  ALIGN=\"CENTER\"><B><FONT COLOR=\"#A30856\">\nA seriously silly model of romantic love!\n</FONT></B></H3>\n\n\n<TABLE ALIGN=\"CENTER\" WIDTH=\"80%\" BORDER=\"0\"  CELLSPACING=\"0\"  CELLPADDING=\"8\">\n  <TR VALIGN=\"TOP\">\n    <TD BGCOLOR=\"#DFDFDF\">\n      <FONT COLOR=\"#034826\">\n      <I>How do I love thee? Let me model the ways!</I>\n      </FONT><BR>\n      <FONT SIZE=\"-1\">- My apologies to Elizabeth Barrett Browning\n      for nerdifying her lovely poem!\n      </FONT>\n    </TD>\n  </TR>\n</TABLE>\n\n<P>\n<FONT SIZE=\"-1\">(Adapted from various sources.  But if you're \nseriously interested, check out\n<A HREF=\"http://www.earlham.edu/~pardhan/courses/general_notes/de/DynamicLove.pdf\">this article</A>!)\n</FONT>\n\n<!--\n<P>\n<B>Prelude:</B> Please complete \n<A HREF=\"./quiz_on_love_style.pdf\">this brief self-assessment \nof your romantic personality</A> before working on the \nrest of today's lab.\n-->\n\n<P>\n\n<FONT COLOR=\"#034826\">\n<B>The scene</B>\n</FONT>\n<P>\nJuliet loves Romeo, and Romeo loves Juliet, \nat least at time t=0.  The question is, how will their \nfeelings evolve with time, and as they meet other, potentially \nfascinating, new people!  Here is our modeling strategy:\n\n\n<UL>\n  <LI>We will model the rate of change in their \nfeelings, with respect to time.\n  <LI>Let J(t) = a function that represents Juliet's \nlove for Romeo at time t.  <BR>The sign and magnitude of J(t) \nindicate how much Juliet loves (or hates, if it is \nnegative) Romeo.\n  <LI>Let R(t) = a similar function of Romeo's \nfeelings about Juliet.\n</UL>\n\n<FONT COLOR=\"#034826\">\n<B>Love is an ever changing function</B>\n</FONT>\n<P>&nbsp;<BR>\nTo help you get comfortable with these love functions and their \nphase plots, let us begin with a warmup exercise.\n<P>\n<FONT COLOR=\"#000066\">\nEach graph below shows the time history of various hypothetical \nlove affairs between Juliet and Romeo.  Interpret what is \nhappening in each graph.\n</FONT>\n<TABLE ALIGN=\"CENTER\" WIDTH=\"80%\" BORDER=\"0\"  CELLSPACING=\"0\"  CELLPADDING=\"8\">\n  <TR VALIGN=\"TOP\">\n    <TD ALIGN=\"CENTER\">\n      <IMG SRC=\"./love_affairs_sketch1.png\" width=\"350\">\n    </TD>\n    <TD ALIGN=\"CENTER\">\n      <IMG SRC=\"./love_affairs_sketch2.png\" width=\"350\">\n    </TD>\n  </TR>\n  <TR VALIGN=\"TOP\">\n    <TD ALIGN=\"CENTER\">\n      <B>Fig. 1</B>\n    </TD>\n    <TD ALIGN=\"CENTER\">\n      <B>Fig. 2</B>\n    </TD>\n  </TR>\n\n\n  <TR VALIGN=\"TOP\">\n    <TD ALIGN=\"CENTER\">\n      <IMG SRC=\"./love_affairs_sketch3.png\" width=\"350\">\n    </TD>\n    <TD ALIGN=\"CENTER\">\n      <IMG SRC=\"./love_affairs_sketch4.png\" width=\"350\">\n    </TD>\n  </TR>\n  <TR VALIGN=\"TOP\">\n    <TD ALIGN=\"CENTER\">\n      <B>Fig. 3</B>\n    </TD>\n    <TD ALIGN=\"CENTER\">\n      <B>Fig. 4</B>\n    </TD>\n  </TR>\n</TABLE>\n      \n      \n<FONT COLOR=\"#034826\">\n<B>Building a simple love-affair model</B>\n</FONT>\n<BR>&nbsp;<BR>\nFor simplicity, we will assume that there are only two \nfactors that affect Juliet's future feelings for Romeo: \n(i) her own current feelings about him, and (ii) his \ncurrent feelings towards her.  And similarly, there\nare only two factors that affect Romeo's  future\nfeelings about Juliet. <P>\n\nAs usual, we want to think in terms of the derivatives \n$\\displaystyle \\frac{dJ}{dt}$ and $\\displaystyle \\frac{dR}{dt}$, \nin order to model $J(t)$ and $R(t)$.  Here are some question \nto explore:\n<UL>\n  <LI>Suppose we ignore the magnitudes of\n$J(t)$ and $R(t)$, and consider only their signs.  \nWrite a couple of sentences discussing how many different\ncombinations of feelings are possible, and what they are \n      (e.g., love-hate, love-love,<SUB>&nbsp;</SUB>etc.).\n  <LI>We<SUP>&nbsp;</SUP>want to express \n$J^\\prime(t)$ and $R^\\prime(t)$ as functions of the variables they depend \nupon.  To help you think through this, here is an example of a \nscenario to consider: Suppose Romeo is primarily connected \nto his own feelings and disconnected from Juliet's.  And \nsuppose Juliet has the opposite personality.  Then, one\nsimple model for $J^\\prime$ and $R^\\prime$ would look like: <BR>\n&nbsp; &nbsp; <SUP>&nbsp;</SUP> $J^\\prime(t) = - J + R $ <BR>\n&nbsp; &nbsp; <SUP>&nbsp;</SUP> $R^\\prime(t) = - J + R $\n<P>\nHere the negative signs on the 1st term suggest both \nlovers respond negatively when Juliet's love for Romeo \nincreases!  The positive signs on the 2nd term suggests \nboth lovers fall deeper in love as Romeo's love for \nJuliet increases.  True, it's weird, but there is plenty of \nweirdness in the real world! <P>\n<FONT COLOR=\"#000066\">\nConstruct a few other simple models of this type.  That is: <BR>\n&nbsp; &nbsp; $J^\\prime(t) = $ term(s) that<SUP>&nbsp;</SUP> \ndepend on $J$ and $R$ <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\nExplain what sign you want for the term(s) and why? \n<BR>\n&nbsp; &nbsp; $R^\\prime(t) = $ term(s)<SUP>&nbsp;</SUP>that \ndepend on $J$ and $R$ <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\nExplain what sign you want for the term(s) and why? \n</FONT>\n</UL>\n    \nA general formulation of the model \nthat includes all the cases considered above is <BR>\n\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $J^\\prime(t) = a J + b R $ <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $R^\\prime(t) = c J + d R $ <P>\nwhere all the coefficients denote constant parameter \nvalues that model different personality types and/or \nbehavior traits.  For example, here is one classification \nscheme based on Romeo's personality that has been proposed \nin the literature: \n\n<OL>\n  <LI><I>Eager beaver</I>: $ c > 0$ and $ d > 0$ \n(Romeo is encouraged by his own feelings as well as by Juliet's.)\n  <LI><I>Narcissistic nerd</I>: $ c < 0$ and $ d > 0$ \n(Romeo wants more of what he feels, but retreats from Juliet's \nfeelings.)\n  <LI><I>Cautious lover</I>: $ c > 0$ and $ d < 0$ \n(Romeo retreats from his own feelings, but is encouraged by\nJuliet's.)\n  <LI><I>Hermit</I>: $ c < 0$ and $ d < 0$ \n(Romeo retreats from his own feelings as well as from \nJuliet's.)\n</OL>\n"}︡{"done":true}︡
︠82feebf6-5e07-40d9-9066-ae73b30ebe10si︠
%hide
%html

<FONT COLOR="#034826">
<B>Explore the model's predictions</B>
</FONT>
<BR>&nbsp;<BR>
<FONT COLOR="#000066">
The four parameters $a$, $b$, $c$, $d$, in the general formulation 
above can be chosen to mimic different personality types.  For example, 
an affair between two Eager beavers would correspond to positive 
values for all 4 parameters.  Pick a few different personality 
combinations and explore what the model predicts about their 
love affair.  Be sure to try different starting points for each 
situation; e.g., $J(0)$ , $R(0)$ need not always be positive.  Use 
the interactive Sage script below to carry out your explorations.
</FONT>
︡48a187ce-5d08-4331-b311-b1a8f8451287︡{"hide":"input"}︡{"html":"\n<FONT COLOR=\"#034826\">\n<B>Explore the model's predictions</B>\n</FONT>\n<BR>&nbsp;<BR>\n<FONT COLOR=\"#000066\">\nThe four parameters $a$, $b$, $c$, $d$, in the general formulation \nabove can be chosen to mimic different personality types.  For example, \nan affair between two Eager beavers would correspond to positive \nvalues for all 4 parameters.  Pick a few different personality \ncombinations and explore what the model predicts about their \nlove affair.  Be sure to try different starting points for each \nsituation; e.g., $J(0)$ , $R(0)$ need not always be positive.  Use \nthe interactive Sage script below to carry out your explorations.\n</FONT>\n"}︡{"done":true}︡
︠a2987edf-49f6-4f58-9500-7dfda967dbb2si︠

%hide
# System is: j' = a*j + b*r  ;  r' = c*j + d*r
jl, rl, t = var('jl rl t')
print "Interactive simulation of simple love-affair model."
print "Enter/adjust parameter values for system: dJ/dt = a*J + b*R ;  dR/dt = c*J + d*R"
@interact
def _( a=slider(-5, 5, step_size=0.5, default=1, label='a', width=20), b=slider(-5, 5, step_size=0.5, default=1, label='b', width=20), c=slider(-5, 5, step_size=0.5, default=1, label='c', width=20), d=slider(-5, 5, step_size=0.5, default=1, label='d', width=20), ic_j=input_box(0.5, 'J(0)=', width=20), ic_r=input_box(1, 'R(0)=', width=20), t_end=input_box(5, 'End time=', width=20) ):
    de1 = a*jl + b*rl
    de2 = c*jl + d*rl
    P = desolve_system_rk4 ([de1, de2], [jl, rl], ics=[0, ic_j, ic_r], ivar=t, end_points=[0,t_end] )
    Q = [ [j,k] for i, j, k in P]
    #list_plot(Q, axes_labels=['$S$', '$B$'])
    show(line(Q, axes_labels=['$J$', '$R$'], color='green', thickness=2, title='Phase plot'))

    # The following creates plots of S vs t and B vs t:
    QS = [ [i,j] for i, j, k in P]
    QB = [ [i,k] for i, j, k in P]
    SS = line(QS, axes_labels=['$t$', 'J/R'], legend_label='J', color='blue', thickness=2)
    SB = line(QB, axes_labels=['$t$', 'J/R'], legend_label='R', color='green', thickness=2)
    show(SS+SB)
︡ee4ecc41-7253-4f29-8ab0-4089f72f382e︡{"hide":"input"}︡{"stdout":"Interactive simulation of simple love-affair model.\n"}︡{"stdout":"Enter/adjust parameter values for system: dJ/dt = a*J + b*R ;  dR/dt = c*J + d*R\n"}︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":12,"display_value":true,"label":"a","vals":["-5.00000000000000","-4.50000000000000","-4.00000000000000","-3.50000000000000","-3.00000000000000","-2.50000000000000","-2.00000000000000","-1.50000000000000","-1.00000000000000","-0.500000000000000","0.000000000000000","0.500000000000000","1.00000000000000","1.50000000000000","2.00000000000000","2.50000000000000","3.00000000000000","3.50000000000000","4.00000000000000","4.50000000000000","5.00000000000000"],"var":"a","width":20},{"animate":true,"control_type":"slider","default":12,"display_value":true,"label":"b","vals":["-5.00000000000000","-4.50000000000000","-4.00000000000000","-3.50000000000000","-3.00000000000000","-2.50000000000000","-2.00000000000000","-1.50000000000000","-1.00000000000000","-0.500000000000000","0.000000000000000","0.500000000000000","1.00000000000000","1.50000000000000","2.00000000000000","2.50000000000000","3.00000000000000","3.50000000000000","4.00000000000000","4.50000000000000","5.00000000000000"],"var":"b","width":20},{"animate":true,"control_type":"slider","default":12,"display_value":true,"label":"c","vals":["-5.00000000000000","-4.50000000000000","-4.00000000000000","-3.50000000000000","-3.00000000000000","-2.50000000000000","-2.00000000000000","-1.50000000000000","-1.00000000000000","-0.500000000000000","0.000000000000000","0.500000000000000","1.00000000000000","1.50000000000000","2.00000000000000","2.50000000000000","3.00000000000000","3.50000000000000","4.00000000000000","4.50000000000000","5.00000000000000"],"var":"c","width":20},{"animate":true,"control_type":"slider","default":12,"display_value":true,"label":"d","vals":["-5.00000000000000","-4.50000000000000","-4.00000000000000","-3.50000000000000","-3.00000000000000","-2.50000000000000","-2.00000000000000","-1.50000000000000","-1.00000000000000","-0.500000000000000","0.000000000000000","0.500000000000000","1.00000000000000","1.50000000000000","2.00000000000000","2.50000000000000","3.00000000000000","3.50000000000000","4.00000000000000","4.50000000000000","5.00000000000000"],"var":"d","width":20},{"control_type":"input-box","default":"0.500000000000000","label":"J(0)=","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"ic_j","width":20},{"control_type":"input-box","default":1,"label":"R(0)=","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"ic_r","width":20},{"control_type":"input-box","default":5,"label":"End time=","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"t_end","width":20}],"flicker":false,"id":"1864c144-3756-402c-89b2-0671b4904813","layout":[[["a",12,null]],[["b",12,null]],[["c",12,null]],[["d",12,null]],[["ic_j",12,null]],[["ic_r",12,null]],[["t_end",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠43f881e8-957e-43a8-b816-35a210dd4cc9si︠
%hide
%html

<FONT COLOR="#034826">
<B>A contrived love affair</B>
</FONT>
<BR>&nbsp;<BR>
It is not too hard to design a model to mimic any 
long-term behavior we want. For example, suppose we want both 
lovers to stay in love permanently, after an initial period of 
meandering and uncertainty! Consider the following model: <P><BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $J^\prime(t) = -0.2(J-3) - (R-4) $ <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $R^\prime(t) =  (J-3) - 0.2(R-4) $ <P><BR>

<FONT COLOR="#000066">
Pick any choice of initial values for $J$ and $R$ -- in fact, 
try various combinations such as hate-hate, love-hate, etc.  
Use the Sage script below to run these simulations and discuss 
your results: what are the values of $J(t)$ and $R(t)$ 
in the long-term? arguing from a calculus perspective, 
can you conjecture why? what are the personality types of 
Romeo and Juliet in this model (e.g., Eager beaver, 
Narcissistic nerd, etc.)? Can you think of a simple 
change to the model that would make them both hate each
other in the long-term?
</FONT>
︡eff074c4-e9df-41eb-87c0-9e02ea618655︡{"hide":"input"}︡{"html":"\n<FONT COLOR=\"#034826\">\n<B>A contrived love affair</B>\n</FONT>\n<BR>&nbsp;<BR>\nIt is not too hard to design a model to mimic any \nlong-term behavior we want. For example, suppose we want both \nlovers to stay in love permanently, after an initial period of \nmeandering and uncertainty! Consider the following model: <P><BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $J^\\prime(t) = -0.2(J-3) - (R-4) $ <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $R^\\prime(t) =  (J-3) - 0.2(R-4) $ <P><BR>\n\n<FONT COLOR=\"#000066\">\nPick any choice of initial values for $J$ and $R$ -- in fact, \ntry various combinations such as hate-hate, love-hate, etc.  \nUse the Sage script below to run these simulations and discuss \nyour results: what are the values of $J(t)$ and $R(t)$ \nin the long-term? arguing from a calculus perspective, \ncan you conjecture why? what are the personality types of \nRomeo and Juliet in this model (e.g., Eager beaver, \nNarcissistic nerd, etc.)? Can you think of a simple \nchange to the model that would make them both hate each\nother in the long-term?\n</FONT>"}︡{"done":true}︡
︠d46f042e-e2a1-40ea-b240-7f237c270ed6s︠
%hide
# System is: j' = -0.2*(j-3) - (r-4)  ;  r' = (j-3) - 0.2(r-4)
j, r, t = var('j r t')
print "Interactive simulation of model: j' = -0.2*(j-3) - (r-4) ,  r' = (j-3) - 0.2(r-4)"
print "Enter initial values for J and R"
@interact
def _( ic_j=input_box(0.5, '$J(0)=$', width=20), ic_r=input_box(1, '$R(0)=$', width=20), t_end=input_box(10, 'End time=', width=20) ):
    de1 = -0.2*(j-3) - (r-4)
    de2 = (j-3) - 0.2*(r-4)
    P = desolve_system_rk4 ([de1, de2], [j, r], ics=[0, ic_j, ic_r], ivar=t, end_points=[0,t_end] )
    Q = [ [jc,k] for i, jc, k in P]
    #list_plot(Q, axes_labels=['$S$', '$B$'])
    show(line(Q, axes_labels=['$J$', '$R$'], color='green', thickness=2, title='Phase plot'))

    # The following creates plots of S vs t and B vs t:
    QS = [ [i,jc] for i, jc, k in P]
    QB = [ [i,k] for i, jc, k in P]
    SS = line(QS, axes_labels=['$t$', 'J/R'], legend_label='J', color='blue', thickness=2)
    SB = line(QB, axes_labels=['$t$', 'J/R'], legend_label='R', color='green', thickness=2)
    show(SS+SB)
︡7ec88b43-9304-4a57-9767-ccd59445e5f9︡{"hide":"input"}︡{"stdout":"Interactive simulation of model: j' = -0.2*(j-3) - (r-4) ,  r' = (j-3) - 0.2(r-4)\n"}︡{"stdout":"Enter initial values for J and R\n"}︡{"interact":{"controls":[{"control_type":"input-box","default":"0.500000000000000","label":"$J(0)=$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"ic_j","width":20},{"control_type":"input-box","default":1,"label":"$R(0)=$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"ic_r","width":20},{"control_type":"input-box","default":10,"label":"End time=","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"t_end","width":20}],"flicker":false,"id":"c3e69804-a1db-464c-8c62-4873eb04f9eb","layout":[[["ic_j",12,null]],[["ic_r",12,null]],[["t_end",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠d4515c4a-e8f8-432b-8948-c75a1dd077a8si︠

%hide
%html

<FONT COLOR="#034826">
<B>The mathematics behind it</B>
</FONT>
<BR>&nbsp;<BR>
First, note the fixed points of the system: <P><BR>

&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $J^\prime(t) = -0.2(J-3) - (R-4) $ <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $R^\prime(t) =  (J-3) - 0.2(R-4) $ <P>
Next, let's look at the Jacobian matrix and is eigenvalues.  
Since the system is linear, the terms in the Jacobian (say, $\bf A$) are 
just the coefficients:
$ {\bf A} = \left[\begin{array}{cc} -0.2 & -1  \\ 
     1 & -0.2 \end{array}\right]$  <P>

Its eigenvalues are found using the Sage segment below.

︡54d766a1-8406-4f74-9d20-ec7eddb7762d︡{"hide":"input"}︡{"html":"\n<FONT COLOR=\"#034826\">\n<B>The mathematics behind it</B>\n</FONT>\n<BR>&nbsp;<BR>\nFirst, note the fixed points of the system: <P><BR>\n\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $J^\\prime(t) = -0.2(J-3) - (R-4) $ <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $R^\\prime(t) =  (J-3) - 0.2(R-4) $ <P>\nNext, let's look at the Jacobian matrix and is eigenvalues.  \nSince the system is linear, the terms in the Jacobian (say, $\\bf A$) are \njust the coefficients:\n$ {\\bf A} = \\left[\\begin{array}{cc} -0.2 & -1  \\\\ \n     1 & -0.2 \\end{array}\\right]$  <P>\n\nIts eigenvalues are found using the Sage segment below.\n\n"}︡{"done":true}︡
︠2b4348b7-1457-41f6-90ba-d6cb57214a4ds︠
# Define Jacobian matrix by rows in brackets [] separated by commas
A = matrix( [ [-0.2, -1], [1, -0.2] ] )
# Find eigenvalues of matrix
A.eigenvalues()
︡b515272f-33b9-43ed-843e-caa837d8bb6b︡{"stdout":"[-0.200000000000000 - 1.00000000000000*I, -0.200000000000000 + 1.00000000000000*I]\n"}︡{"stderr":"<string>:1: UserWarning: Using generic algorithm for an inexact ring, which will probably give incorrect results due to numerical precision issues.\n"}︡{"done":true}︡
︠f08821ec-cddb-479b-884e-f5701f3eaf11is︠
%hide
%html

Notice the eigenvalues are complex conjugates, with negative 
real part.  These types of eigenvalues always attract the 
solution to the fixed point in an oscillating pattern.  Hence, 
the phase plot displays converging spiral solutions.  <P><BR>

An easy way to change the problem and make the solution 
diverge would be to change the matrix so 
its eigenvalues are positive.  For example, 
$ {\bf A} = \left[\begin{array}{cc} 0.2 & -1  \\ 
     1 & 0.2 \end{array}\right]$ has complex conjugate 
eigenvalues with positive real part.  Thus, the following system 
will have only diverging spiral solutions  <P>

&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $J^\prime(t) = 0.2(J-3) - (R-4) $ <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; $R^\prime(t) =  (J-3) + 0.2(R-4) $ 
︡96c5aa69-48d2-4821-97d3-668b828cf62a︡{"hide":"input"}︡{"html":"\nNotice the eigenvalues are complex conjugates, with negative \nreal part.  These types of eigenvalues always attract the \nsolution to the fixed point in an oscillating pattern.  Hence, \nthe phase plot displays converging spiral solutions.  <P><BR>\n\nAn easy way to change the problem and make the solution \ndiverge would be to change the matrix so \nits eigenvalues are positive.  For example, \n$ {\\bf A} = \\left[\\begin{array}{cc} 0.2 & -1  \\\\ \n     1 & 0.2 \\end{array}\\right]$ has complex conjugate \neigenvalues with positive real part.  Thus, the following system \nwill have only diverging spiral solutions  <P>\n\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $J^\\prime(t) = 0.2(J-3) - (R-4) $ <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; $R^\\prime(t) =  (J-3) + 0.2(R-4) $ "}︡{"done":true}︡
︠f50a231a-f746-4167-9823-2adfb0d475dbis︠
%hide
%html

<FONT COLOR="#034826">
<H5>More complex love affairs</H5>
</FONT>

The models we have seen so far are all linear, and their 
solutions exhibit a fairly limited range of behaviors.  
As you might suspect, things get much more interesting 
when we try to model non-linear personalities, or other 
more complicated situations such as 
3-way affairs or polyamorous relationships. <P>

<OL>
  <LI><B>Nonlinear personalities</B> <BR>
Here is one simple way to make the Juliet-Romeo 
model nonlinear 
<BR>

&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; <TT>J'(t) = a J + b R(1-|R|) </TT> <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; <TT>R'(t) = c J(1-|J|) + d R </TT> <P>
Can you conjecture what type of real-life behavior 
the nonlinear terms might capture (assume <TT>b</TT> 
and <TT>c</TT> are positive)?  
Depending on the choice of parameters, different solution 
behaviors can be seen.  For example, try to run some 
simulations with <TT>a=b=-2</TT> 
and <TT>c=d=1</TT>.  To really understand what is going 
on, you will need to try a few different initial values for 
J(0) and R(0).
<P>

  <LI><B>A 3-way affair</B> <BR>
Suppose Juliet has an affair with someone (say, Sky).  
A model will be much easier to develop if she keeps 
the affair a secret from Romeo!  In that case there 
will be 2 equations for Juliet, plus 1 each for Romeo and 
Sky.  Here is one example of such a model <P>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; <TT>J<SUB>R</SUB>'(t) = 
    a J<SUB>R</SUB> + b (R-S) </TT> <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; <TT>J<SUB>S</SUB>'(t) = 
    a J<SUB>S</SUB> + b (S-R) </TT> <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; <TT>R'(t) = c J<SUB>R</SUB> + d R </TT> <BR>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; <TT>S'(t) = e J<SUB>S</SUB> + f S </TT> <P>

where <TT>J<SUB>R</SUB>(t)</TT> and 
<TT>J<SUB>S</SUB>(t)</TT> are functions 
that represent Juliet's love for Romeo and 
Sky, respectively.  As before, <TT>R(t)</TT> and 
<TT>S(t)</TT> represent the respective partners' 
love for Juliet.  If you assume positive parameter values 
for <TT>a-f</TT>, can you conjecture meaningful 
interpretations for all the terms in this model? <P>

Despite the seeming complexity of this last model, it is 
still linear, and has a fairly limited range of solution 
behaviors.  To see chaotic solution behaviors 
it is necessary to include nonlinear terms in the model.

︡ba2a08de-57f2-4489-af62-7ce8d358a22e︡{"hide":"input"}︡{"html":"\n<FONT COLOR=\"#034826\">\n<H5>More complex love affairs</H5>\n</FONT>\n\nThe models we have seen so far are all linear, and their \nsolutions exhibit a fairly limited range of behaviors.  \nAs you might suspect, things get much more interesting \nwhen we try to model non-linear personalities, or other \nmore complicated situations such as \n3-way affairs or polyamorous relationships. <P>\n\n<OL>\n  <LI><B>Nonlinear personalities</B> <BR>\nHere is one simple way to make the Juliet-Romeo \nmodel nonlinear \n<BR>\n\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; <TT>J'(t) = a J + b R(1-|R|) </TT> <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; <TT>R'(t) = c J(1-|J|) + d R </TT> <P>\nCan you conjecture what type of real-life behavior \nthe nonlinear terms might capture (assume <TT>b</TT> \nand <TT>c</TT> are positive)?  \nDepending on the choice of parameters, different solution \nbehaviors can be seen.  For example, try to run some \nsimulations with <TT>a=b=-2</TT> \nand <TT>c=d=1</TT>.  To really understand what is going \non, you will need to try a few different initial values for \nJ(0) and R(0).\n<P>\n\n  <LI><B>A 3-way affair</B> <BR>\nSuppose Juliet has an affair with someone (say, Sky).  \nA model will be much easier to develop if she keeps \nthe affair a secret from Romeo!  In that case there \nwill be 2 equations for Juliet, plus 1 each for Romeo and \nSky.  Here is one example of such a model <P>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; <TT>J<SUB>R</SUB>'(t) = \n    a J<SUB>R</SUB> + b (R-S) </TT> <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; <TT>J<SUB>S</SUB>'(t) = \n    a J<SUB>S</SUB> + b (S-R) </TT> <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; <TT>R'(t) = c J<SUB>R</SUB> + d R </TT> <BR>\n&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n&nbsp; &nbsp; <TT>S'(t) = e J<SUB>S</SUB> + f S </TT> <P>\n\nwhere <TT>J<SUB>R</SUB>(t)</TT> and \n<TT>J<SUB>S</SUB>(t)</TT> are functions \nthat represent Juliet's love for Romeo and \nSky, respectively.  As before, <TT>R(t)</TT> and \n<TT>S(t)</TT> represent the respective partners' \nlove for Juliet.  If you assume positive parameter values \nfor <TT>a-f</TT>, can you conjecture meaningful \ninterpretations for all the terms in this model? <P>\n\nDespite the seeming complexity of this last model, it is \nstill linear, and has a fairly limited range of solution \nbehaviors.  To see chaotic solution behaviors \nit is necessary to include nonlinear terms in the model."}︡{"done":true}︡









