︠fe2aea64-92f4-4610-9b2d-b601bb6eb8adsi︠
%hide
%html

<H3  ALIGN="CENTER"><B><FONT COLOR="#030856">
The elevator problem
</FONT></B></H3>

<FONT SIZE="-1">(Adapted from 
"<A HREF="http://www.siam.org/reports/gaimme-full_color_for_online_viewing.pdf">
The GAIMME report</A>.")
</FONT>
<P><BR>
<TABLE ALIGN="CENTER" WIDTH="80%" BORDER="0"  CELLSPACING="0"  CELLPADDING="8">
  <TR VALIGN="TOP">
    <TD ALIGN="CENTER">
      <IMG SRC="./elevator_photo.jpg" width="650">
    </TD>
  </TR>
</TABLE>

<FONT COLOR="#800000" SIZE="+1">
MEMO
</FONT>  <P><BR>
<B>From:</B> Your Boss  <BR>
<B>To:</B> You          <BR>
<B>Re:</B> Late Arrivals 
<P><BR>
I have received numerous complaints that large numbers of our 
    employees are reaching their offices well after 9:00 a.m. due 
    to the inability of the present three elevators to cope with 
    the rush at the start of the day. In the present financial 
    situation it is impossible to consider installing any extra 
    elevators or increasing the capacity of existing ones above 
    the current ten persons. Please investigate and let me have 
    some possible solutions to the problem with an indication of 
    their various advantages and disadvantages.


︡eb0fa042-21c7-4007-9973-afc5bf4f2a7f︡{"hide":"input"}︡{"html":"\n<H3  ALIGN=\"CENTER\"><B><FONT COLOR=\"#030856\">\nThe elevator problem\n</FONT></B></H3>\n\n<FONT SIZE=\"-1\">(Adapted from \n\"<A HREF=\"http://www.siam.org/reports/gaimme-full_color_for_online_viewing.pdf\">\nThe GAIMME report</A>.\")\n</FONT>\n<P><BR>\n<TABLE ALIGN=\"CENTER\" WIDTH=\"80%\" BORDER=\"0\"  CELLSPACING=\"0\"  CELLPADDING=\"8\">\n  <TR VALIGN=\"TOP\">\n    <TD ALIGN=\"CENTER\">\n      <IMG SRC=\"./elevator_photo.jpg\" width=\"650\">\n    </TD>\n  </TR>\n</TABLE>\n\n<FONT COLOR=\"#800000\" SIZE=\"+1\">\nMEMO\n</FONT>  <P><BR>\n<B>From:</B> Your Boss  <BR>\n<B>To:</B> You          <BR>\n<B>Re:</B> Late Arrivals \n<P><BR>\nI have received numerous complaints that large numbers of our \n    employees are reaching their offices well after 9:00 a.m. due \n    to the inability of the present three elevators to cope with \n    the rush at the start of the day. In the present financial \n    situation it is impossible to consider installing any extra \n    elevators or increasing the capacity of existing ones above \n    the current ten persons. Please investigate and let me have \n    some possible solutions to the problem with an indication of \n    their various advantages and disadvantages.\n"}︡{"done":true}︡
︠38c3df39-9dee-4751-99a4-0b7c9dc98788si︠
%hide
%html
<FONT COLOR="#000080" SIZE="+1">
How to solve the problem of employees coming in late due to 
inability of elevators to handle peak demand?
</FONT>
<P><BR>
We want to develop a mathematical model to understand the 
nature of this problem, and to propose a solution.  <P>
As a start, 
let us brainstorm some ideas about how to approach the problem.  
<P>
What are your thoughts?  Discuss!



︡afd01169-9b0e-465b-83fe-30a20052d192︡{"hide":"input"}︡{"html":"<FONT COLOR=\"#000080\" SIZE=\"+1\">\nHow to solve the problem of employees coming in late due to \ninability of elevators to handle peak demand?\n</FONT>\n<P><BR>\nWe want to develop a mathematical model to understand the \nnature of this problem, and to propose a solution.  <P>\nAs a start, \nlet us brainstorm some ideas about how to approach the problem.  \n<P>\nWhat are your thoughts?  Discuss!\n\n"}︡{"done":true}︡
︠f0a484de-d439-4217-8095-cf49f833ae4csi︠

%hide
%html
<FONT COLOR="#000080" SIZE="+1">
<B>Strategy 1</B>
</FONT>
<P><BR>
Perhaps a good starting point is to try to understand how 
severe the current problem is, in terms of time.  
Let us try to estimate the total time the elevators currently 
take to get all the employees to their respective floors.  
In order to do this, we need to get some more information, and 
also must make some simplifying assumptions.
<P>
For example, here are some items of information we need:
<UL>
  <LI>What is the capacity of each elevator? (i.e., how many people can be in it?) 
  <LI>How many floors are in the building?
  <LI>How many employees work on each floor?
</UL>

Suppose each of the 3 elevators can accommodate 
10 peolple; and there are 6 floors in the building, including a 
ground floor on which no employees work.  There are 300 employees 
total, distributed approximately equally across the 5 occupied 
floors.  So the situation looks something like this:  <P><BR>
<TABLE ALIGN="CENTER" WIDTH="80%" BORDER="1"  CELLSPACING="0"  CELLPADDING="8">
  <TR ALIGN="CENTER" VALIGN="TOP">
    <TD ALIGN="CENTER" BGCOLOR="8888FF" WIDTH="10%">
      Floor
    </TD>
    <TD>
      G
    </TD>
    <TD>
      1st
    </TD>
    <TD>
      2nd
    </TD>
    <TD>
      3rd
    </TD>
    <TD>
      4th
    </TD>
    <TD>
      5th
    </TD>
  </TR>
  <TR ALIGN="CENTER" VALIGN="TOP">
    <TD BGCOLOR="8888FF" WIDTH="10%">
      Employees
    </TD>
    <TD>
      0
    </TD>
    <TD>
      60
    </TD>
    <TD>
      60
    </TD>
    <TD>
      60
    </TD>
    <TD>
      60
    </TD>
    <TD>
      60
    </TD>
  </TR>
</TABLE>
<P><BR>

<FONT COLOR="#000080">
<B>Exercise</B>
</FONT>
<P>
Estimate the total time the elevators take to get all 
the employees in the building to their respective floors. <BR>
If you need more information or data, please feel free 
to ask.  Also, feel free to make any reasonable 
assumptions needed.


︡3af4006c-d0d6-4ce9-b1f4-2dfa8e82dd99︡{"hide":"input"}︡{"html":"<FONT COLOR=\"#000080\" SIZE=\"+1\">\n<B>Strategy 1</B>\n</FONT>\n<P><BR>\nPerhaps a good starting point is to try to understand how \nsevere the current problem is, in terms of time.  \nLet us try to estimate the total time the elevators currently \ntake to get all the employees to their respective floors.  \nIn order to do this, we need to get some more information, and \nalso must make some simplifying assumptions.\n<P>\nFor example, here are some items of information we need:\n<UL>\n  <LI>What is the capacity of each elevator? (i.e., how many people can be in it?) \n  <LI>How many floors are in the building?\n  <LI>How many employees work on each floor?\n</UL>\n\nSuppose each of the 3 elevators can accommodate \n10 peolple; and there are 6 floors in the building, including a \nground floor on which no employees work.  There are 300 employees \ntotal, distributed approximately equally across the 5 occupied \nfloors.  So the situation looks something like this:  <P><BR>\n<TABLE ALIGN=\"CENTER\" WIDTH=\"80%\" BORDER=\"1\"  CELLSPACING=\"0\"  CELLPADDING=\"8\">\n  <TR ALIGN=\"CENTER\" VALIGN=\"TOP\">\n    <TD ALIGN=\"CENTER\" BGCOLOR=\"8888FF\" WIDTH=\"10%\">\n      Floor\n    </TD>\n    <TD>\n      G\n    </TD>\n    <TD>\n      1st\n    </TD>\n    <TD>\n      2nd\n    </TD>\n    <TD>\n      3rd\n    </TD>\n    <TD>\n      4th\n    </TD>\n    <TD>\n      5th\n    </TD>\n  </TR>\n  <TR ALIGN=\"CENTER\" VALIGN=\"TOP\">\n    <TD BGCOLOR=\"8888FF\" WIDTH=\"10%\">\n      Employees\n    </TD>\n    <TD>\n      0\n    </TD>\n    <TD>\n      60\n    </TD>\n    <TD>\n      60\n    </TD>\n    <TD>\n      60\n    </TD>\n    <TD>\n      60\n    </TD>\n    <TD>\n      60\n    </TD>\n  </TR>\n</TABLE>\n<P><BR>\n\n<FONT COLOR=\"#000080\">\n<B>Exercise</B>\n</FONT>\n<P>\nEstimate the total time the elevators take to get all \nthe employees in the building to their respective floors. <BR>\nIf you need more information or data, please feel free \nto ask.  Also, feel free to make any reasonable \nassumptions needed.\n"}︡{"done":true}︡
︠0dcbe150-d7c6-4d5c-bbf5-31d745adea67sio︠
%hide
%html

<TABLE ALIGN="CENTER" WIDTH="80%" BORDER="0"  CELLSPACING="0"  CELLPADDING="8">
  <TR VALIGN="TOP">
    <TD>
<FONT COLOR="#000080">
One possible solution
</FONT>
<P><BR>

This solution is based on the following assumptions:

<OL>
  <LI>Once the employees start arriving, they come in a steady 
stream until everyone gets to their floor.
  <LI>The elevator will need to stop at every floor on the way up. 
  <LI>On the way down, it will not need to stop anywhere.
  <LI>The elevator doors will need to open only once 
on each floor.
</OL>

Other information we need/get from measurements: <BR><BR>
<UL>
  <LI>It takes 5 seconds for the elevator to travel 
from one floor to the next.
  <LI>It takes 15 seconds for the  elevator doors to 
open/close and let people off at each floor.
  <LI>On the ground floor it takes 25 seconds for the elevator 
to fill up and close its doors.
</UL>
<BR>
The sketch summarizes this information.  It is now straightforward 
to compute the time it takes to complete one full trip (from the 
ground floor to the top, and then back down).
    </TD>

    <TD>
      <IMG SRC="./elevator_transit.png" width="300">
    </TD>
  </TR>
</TABLE>


︡a6db0971-e53e-42eb-84c9-92eef1644188︡{"hide":"input"}︡{"html":"\n<TABLE ALIGN=\"CENTER\" WIDTH=\"80%\" BORDER=\"0\"  CELLSPACING=\"0\"  CELLPADDING=\"8\">\n  <TR VALIGN=\"TOP\">\n    <TD>\n<FONT COLOR=\"#000080\">\nOne possible solution\n</FONT>\n<P><BR>\n\nThis solution is based on the following assumptions:\n\n<OL>\n  <LI>Once the employees start arriving, they come in a steady \nstream until everyone gets to their floor.\n  <LI>The elevator will need to stop at every floor on the way up. \n  <LI>On the way down, it will not need to stop anywhere.\n  <LI>The elevator doors will need to open only once \non each floor.\n</OL>\n\nOther information we need/get from measurements: <BR><BR>\n<UL>\n  <LI>It takes 5 seconds for the elevator to travel \nfrom one floor to the next.\n  <LI>It takes 15 seconds for the  elevator doors to \nopen/close and let people off at each floor.\n  <LI>On the ground floor it takes 25 seconds for the elevator \nto fill up and close its doors.\n</UL>\n<BR>\nThe sketch summarizes this information.  It is now straightforward \nto compute the time it takes to complete one full trip (from the \nground floor to the top, and then back down).\n    </TD>\n\n    <TD>\n      <IMG SRC=\"./elevator_transit.png\" width=\"300\">\n    </TD>\n  </TR>\n</TABLE>\n"}︡{"done":true}︡
︠777171ac-8743-4223-914c-90f0df29aa74si︠

n_elev = 3;  n_emps = 300;  n_per_elev = 10
t_between = 5; t_stops = 15; t_ground = 25
t_full_trip = t_ground + 5*t_between + 5*t_stops + 5*t_between
print "Time per elevator roundtrip =", t_full_trip, "sec"
print "Total time to get", n_emps, "employees to their offices =", t_full_trip*(n_emps/n_per_elev)/n_elev, "sec"
︡b99be295-d847-4444-b165-e3c25f225dea︡{"stdout":"Time per elevator roundtrip = 150 sec\n"}︡{"stdout":"Total time to get 300 employees to their offices = 1500 sec\n"}︡{"done":true}︡
︠13d5daee-faea-4728-bc75-9c451264f544si︠

%hide
%html
<FONT COLOR="#000080" SIZE="+0">
Strategy 1 (continued)
</FONT>
<P><BR>
Now that we have an estimate of how much total time is 
required, let's think about ways to reduce it.  <P>
One example is to consider a policy in which one 
elevator is reserved just for the upper floors.  Suppose 
Elevator A only serves floors 4-5, and Elevators B and C 
serve floors 1, 2, 3.  <BR><BR>

<TABLE ALIGN="CENTER" WIDTH="80%" BORDER="1"  CELLSPACING="0"  CELLPADDING="8">
  <TR ALIGN="CENTER" VALIGN="TOP">
    <TD ALIGN="CENTER" BGCOLOR="FF0066">
      <B>Elevator A</B>
    </TD>
    <TD>
      &nbsp;
    </TD>
    <TD ALIGN="CENTER" BGCOLOR="FF0066">
      <B>Elevator B</B>
    </TD>
    <TD>
      &nbsp; 
    </TD>
    <TD ALIGN="CENTER" BGCOLOR="FF0066">
      <B>Elevator C</B>
    </TD>
  </TR>
  <TR ALIGN="CENTER" VALIGN="TOP">
    <TD BGCOLOR="BBBBFF">
      Floors 4-5 only
    </TD>
    <TD>
      &nbsp;
    </TD>
    <TD>
      Floors 1-3 only
    </TD>
    <TD>
      &nbsp;
    </TD>
    <TD>
      Floors 1-3 only
    </TD>
  </TR>
</TABLE>
<P><BR>




<FONT COLOR="#000080">
<B>Exercise</B>
</FONT>
<P>
Estimate the total time the elevators take to get all 
the employees to their respective floors with the above 
policy.

︡69a47674-7d81-4f25-8670-5241f1d95909︡{"hide":"input"}︡{"html":"<FONT COLOR=\"#000080\" SIZE=\"+0\">\nStrategy 1 (continued)\n</FONT>\n<P><BR>\nNow that we have an estimate of how much total time is \nrequired, let's think about ways to reduce it.  <P>\nOne example is to consider a policy in which one \nelevator is reserved just for the upper floors.  Suppose \nElevator A only serves floors 4-5, and Elevators B and C \nserve floors 1, 2, 3.  <BR><BR>\n\n<TABLE ALIGN=\"CENTER\" WIDTH=\"80%\" BORDER=\"1\"  CELLSPACING=\"0\"  CELLPADDING=\"8\">\n  <TR ALIGN=\"CENTER\" VALIGN=\"TOP\">\n    <TD ALIGN=\"CENTER\" BGCOLOR=\"FF0066\">\n      <B>Elevator A</B>\n    </TD>\n    <TD>\n      &nbsp;\n    </TD>\n    <TD ALIGN=\"CENTER\" BGCOLOR=\"FF0066\">\n      <B>Elevator B</B>\n    </TD>\n    <TD>\n      &nbsp; \n    </TD>\n    <TD ALIGN=\"CENTER\" BGCOLOR=\"FF0066\">\n      <B>Elevator C</B>\n    </TD>\n  </TR>\n  <TR ALIGN=\"CENTER\" VALIGN=\"TOP\">\n    <TD BGCOLOR=\"BBBBFF\">\n      Floors 4-5 only\n    </TD>\n    <TD>\n      &nbsp;\n    </TD>\n    <TD>\n      Floors 1-3 only\n    </TD>\n    <TD>\n      &nbsp;\n    </TD>\n    <TD>\n      Floors 1-3 only\n    </TD>\n  </TR>\n</TABLE>\n<P><BR>\n\n\n\n\n<FONT COLOR=\"#000080\">\n<B>Exercise</B>\n</FONT>\n<P>\nEstimate the total time the elevators take to get all \nthe employees to their respective floors with the above \npolicy.\n\n"}︡{"done":true}︡
︠35072758-a71f-469e-ac2f-cc39efcc2e52si︠

%hide
%html
<FONT COLOR="#000080" SIZE="+1">
<B>Discussion</B>
</FONT>
<P>
<UL>
  <LI>It is not difficult to try out other policies about 
the floor(s) each elevator serves.  Try one of your 
own variations. <P>
  <LI>After our simple initial approach, it is now easier to 
relax or change our initial assumptions and make them 
more realistic. <BR>
For example suppose there is a 20% probability that an elevator 
must stop on the way down. How can we account for that? <P>
  <LI>Also, suppose the number of employees working on a particulr 
floor is much higher than on other floors. <BR>
How can we modify our 
strategy to account for it?
</UL>
︡d84f6d13-71b0-4f24-a7df-60ea29ff220e︡{"hide":"input"}︡{"html":"<FONT COLOR=\"#000080\" SIZE=\"+1\">\n<B>Discussion</B>\n</FONT>\n<P>\n<UL>\n  <LI>It is not difficult to try out other policies about \nthe floor(s) each elevator serves.  Try one of your \nown variations. <P>\n  <LI>After our simple initial approach, it is now easier to \nrelax or change our initial assumptions and make them \nmore realistic. <BR>\nFor example suppose there is a 20% probability that an elevator \nmust stop on the way down. How can we account for that? <P>\n  <LI>Also, suppose the number of employees working on a particulr \nfloor is much higher than on other floors. <BR>\nHow can we modify our \nstrategy to account for it?\n</UL>"}︡{"done":true}︡









